(defun unmerge-pathnames (pathspec
                          &optional (default *default-pathname-defaults*))
  "Removes those leading directory components from PATHSPEC that
are shared with DEFAULT."
  (let ((default-directory (pathname-directory default)))
    (if default-directory
	(let* ((dir (pathname-directory pathspec))
	       (mismatch (mismatch dir default-directory :test #'equal)))
	  (make-pathname :directory (when mismatch
				      `(:relative ,@(subseq dir mismatch)))
			 :defaults pathspec))
	pathspec)))
